
PAGE  59,132

;
;								         
;                             IP_08                                    
;	Changes bytes in memory in timer range. FIXs on INT 08h.	 
;	(c) Stas Levitsky, 1992 					 
;								         
;

psp_cmd_tail	equ	81h

seg_a		segment	byte public
		assume	cs:seg_a, ds:seg_a
		org	100h
dump		proc	far

START::		jmp	loc_10

dump		endp

;
;
;                       INT 08h External Interrupt
;
;

int_08h_entry	proc	far
		cli
		pushf
                push    es
		push	ax
		push	bx
		push	cx
                push    dx

		inc	cs:TICKS
                cmp     cs:TICKS,30     ;; Change this -> get delay
		jne	JMP_OLD8	;; No -> old INT 08h
		mov	cs:TICKS,0

                mov     ax,0FF08h
                int     12h             ;; CALL CRACK ENTRY

JMP_OLD8::
                pop     dx
                pop     cx
		pop	bx
		pop	ax
                pop     es
		popf
		sti
		db	0EAh   ;; Jmp to old INT 08h
INT08OFF        dw      0000h
INT08SEG        dw      0000h
int_08h_entry	endp

;
;
;			INT 12h (CRACK) External Interrupt
;			To call: INT 12h, AX=0FF09h => Changes Bytes
;			To ask : INT 12h, AX=0FF19h => AX="08"
;
;

CRACK_ENTRY     proc    far		;; INT 12h, AX=0FF08h
                cli
                cmp     ax,0FF08h
                je      WORK
		cmp	ax,0FF18h
		je	ASK_INST

OLD12INT:       sti
		db	0EAh
INT12OFF        dw      0000h
INT12SEG        dw      0000h

ASK_INST::	mov	ax,"08"
		sti
		iret
WORK::
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		in	al,60h
		cmp	al,57h
		je	F11
		cmp	al,58h
		je	F12
		cmp	al,46h	;; Scroll Lock
		je	EXIT_2
		jmp	CHANGE
F12::		mov	cs:FLAG,1	;; Turn on
		jmp	CHANGE
F11::		mov	cs:FLAG,0	;; Turn off
		jmp	CHANGE

CHANGE::	cmp	cs:FLAG,0
		je	EXIT_1
		mov	ah,62h
		int	21h
                add     bx,3000h
                mov     es,bx

		jmp	MOV_K
EXIT_1::	jmp	EXIT
EXIT_2::	jmp	KEYS

MOV_K::		mov     byte ptr es:[098A9h],99  ;; 1'st Hero's LIFE
                mov     byte ptr es:[098ABh],99  ;; 1'st Hero's MAX LIFE
                mov     byte ptr es:[098B3h],100 ;; 1'st Hero's FOOD

                mov     byte ptr es:[09A02h],99  ;; 2'st Hero's LIFE
                mov     byte ptr es:[09A04h],99  ;; 2'st Hero's MAX LIFE
                mov     byte ptr es:[09A0Ch],100 ;; 2'st Hero's FOOD

                mov     byte ptr es:[09B5Bh],99  ;; 3'st Hero's LIFE
                mov     byte ptr es:[09B5Dh],99  ;; 3'st Hero's MAX LIFE
                mov     byte ptr es:[09B65h],100 ;; 3'st Hero's FOOD

                mov     byte ptr es:[09CB4h],99  ;; 4'st Hero's LIFE
                mov     byte ptr es:[09CB6h],99  ;; 4'st Hero's MAX LIFE
                mov     byte ptr es:[09CBEh],100 ;; 4'st Hero's FOOD

		mov	byte ptr es:[09E0Dh],99  ;; 5'st Hero LIFE
		mov	byte ptr es:[09E0Fh],99  ;; 5'st Hero MAX LIFE
                mov     byte ptr es:[09E17h],100 ;; 5'st Hero FOOD

                mov     byte ptr es:[09F66h],99  ;; 6'st Hero LIFE
                mov     byte ptr es:[09F68h],99  ;; 6'st Hero MAX LIFE
                mov     byte ptr es:[09F70h],100 ;; 6'st Hero FOOD

                mov     byte ptr es:[098C7h],1Eh ;; Diff. MAGIC WEAPON:
                mov     byte ptr es:[098C8h],02h ;; (1'st Hero must be MAGE &
                mov     byte ptr es:[098C9h],04h ;; CLERIC)
		;;mov	byte ptr es:[098CAh],0Dh ;; - FIREBALL hangs...
                mov     byte ptr es:[09917h],15h ;;
                mov     byte ptr es:[09918h],17h ;;

                jmp     EXIT

KEYS::		mov	ah,62h
		int	21h
		add	bx,3000h
		mov	es,bx
                mov     word ptr es:[09D7Ah],6Fh ;;11h 4'st Hero's KEYS:
                mov     word ptr es:[09D7Ch],70h ;;
                mov     word ptr es:[09D7Eh],1Dh ;;
                mov     word ptr es:[09D80h],8Dh ;; 1Eh
                mov     word ptr es:[09D82h],26h ;;
                mov     word ptr es:[09D84h],40h ;;
                mov     word ptr es:[09D86h],41h ;;
                mov     word ptr es:[09D88h],48h ;;
                mov     word ptr es:[09D8Ah],4Dh ;;
		mov	word ptr es:[09D8Ch],4Eh ;;
                mov     word ptr es:[09D8Eh],4Fh ;;
		mov	word ptr es:[09D90h],0189h ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EXIT::		sti
		iret
CRACK_ENTRY	endp

;
;
;			INT 21h External Interrupt
;                       FIXes changing INTs: 08h, 12h, 21h
;
;

int_21h_entry       proc    far
                cli
		cmp	ax,2521h
		je	SET_21
		cmp	ax,3521h
		je	GET_21
                cmp     ax,2508h        ;; DS:DX
                je      SET_08
                cmp     ax,3508h        ;; ES:BX
                je      GET_08
                cmp     ax,2512h
                je      SET_12
                cmp     ax,3512h
                je      GET_12

OLD21INT:	sti
		db	0EAh
INT21OFF	dw	0000h
INT21SEG	dw	0000h

SET_08::        mov     cs:INT08SEG,ds
                mov     cs:INT08OFF,dx
                sti
                iret
GET_08::        mov      es,cs:INT08SEG
                mov      bx,cs:INT08OFF
                sti
                iret

SET_12::        mov     cs:INT12SEG,ds
                mov     cs:INT12OFF,dx
                sti
                iret
GET_12::        mov      es,cs:INT12SEG
                mov      bx,cs:INT12OFF
                sti
                iret

SET_21::        mov     cs:INT21SEG,ds
                mov     cs:INT21OFF,dx
                popf
                iret
GET_21::        mov     es,cs:INT21SEG
                mov     bx,cs:INT21OFF
                popf
                iret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TICKS           db      0
FLAG		db	0
Q		db	10 dup(0)	;; Shows end of RESIDENT PART
int_21h_entry	endp

;
;
;			External Entry Point
;
;

LOC_10::
		mov	ah,9
		mov	dx,offset TEXT
		int	21h

		mov	ax,0FF18h
		int	12h
		cmp	ax,"08"
		je	ALLREADY08

		mov	ah,9
		mov	dx,offset INST
		int	21h

                mov     ax,3512h
                int     21h                     ; Get intrpt vector al in es:bx
                mov     INT12OFF,bx
                mov     INT12SEG,es
		cli
                mov     ax,0
                mov     es,ax
                mov     es:[00048h],offset CRACK_ENTRY
                mov     es:[0004Ah],cs          ; Set MY vector INT 12h

                mov     ax,3508h
                int     21h                     ; Get intrpt vector al in es:bx
                mov     INT08OFF,bx
                mov     INT08SEG,es
		cli
		mov	ax,0
		mov	es,ax
                mov     es:[00020h],offset INT_08h_ENTRY
                mov     es:[00022h],cs          ; Set MY vector INT 08h

                mov     ax,3521h
		int	21h
		mov	INT21OFF,bx
		mov	INT21SEG,es
		cli
		mov	ax,0
		mov	es,ax
                mov     es:[00084h],offset INT_21h_ENTRY
                mov     es:[00086h],cs          ; Set MY vector INT 21h
                sti

                mov     dx,offset Q             ; Terminate & stay resident
                int     27h                     ;  dx=offset last byte+1, cs=PSP

ALLREADY08:	mov	ah,9
		mov	dx,offset AINST
		int	21h
		ret

TEXT            db 10,"Ϳ",10,13
                db    " -========= IP 08 (c) Stas Levitsky, 1992 ========- ",10,13
                db    " EXHANGED!!! No prob with games, changes 08 Vector! ",10,13
                db    "                                                    ",10,13
                db    " TSR Overlay Program for EYE OF THE BEHOLDER II     ",10,13
                db    "     Will FIX LIFE & FOOD (6 players) every 1 sec   ",10,13
		db    "     Will FIX MAGIC WEAPON (1'st pl.)               ",10,13
		db    "     Press F11/F12 to turn OFF/ON fixing            ",10,13
		db    "     Press Scroll Lock to set ALL KEYS to 4'st Hero ",10,13
                db    "",10,13,"$"

INST		db "Installed Ok.",0ah,0dh,"$"
AINST		db "Already Resident! No action taken",10,13,"$"

seg_a		ends
		end	start
